# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/%{name}/%{version_full}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define version_maj 1
%define version_min 1
%define version_rev 0
%define version_tag SP1
%define version_full %{version_maj}.%{version_min}.%{version_rev}.%{version_tag}
 
Name:           jbossws-common
Version:        %{version_maj}.%{version_min}.%{version_rev}
Release:        1.SP1.2%{?dist}
Epoch:          0
Summary:        JBoss Web Services (common)
License:        LGPLv2+
Group:          Development/Java
URL:            http://labs.jboss.com/jbossws/
# svn -q export http://anonsvn.jboss.org/repos/jbossws/common/tags/jbossws-common-1.1.0.SP1 jbossws-common-1.1.0 && tar cjf jbossws-common-1.1.0.tar.bz2 jbossws-common-1.1.0
Source0:        jbossws-common-1.1.0.tar.bz2
Source1:        jbossws-common-jpp-depmap.xml
Source2:        jbossws-common-settings.xml
Source3:        jbossws-common-component-info.xml
Patch0:         jbossws-common-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
# javax.ejb:ejb-api
BuildRequires:  geronimo-ejb-3.0-api
# javax.mail:mail
BuildRequires:  javamail_1_4_api
# javax.servlet:servlet-api
BuildRequires:  servlet_2_5_api
# javax.xml.ws:jaxws-api
BuildRequires:  glassfish-jaxws
# junit:junit
BuildRequires:  junit
# org.apache.ant:ant
BuildRequires:  ant
# org.jboss:jboss-common-core
BuildRequires:  jboss-common-core
# org.jboss.microcontainer:jboss-dependency
# org.jboss.microcontainer:jboss-kernel
# org.jboss.microcontainer:jboss-microcontainer
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-parent
# org.jboss.ws:jbossws-spi
BuildRequires:  jbossws-spi >= 0:1.1.2
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBossWS Common.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:     Artifacts to be uploaded to a repository library
Group:       Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p0 -b .sav0

%{__cp} -p %{SOURCE2} settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

mkdir -p output/reposave

%build
export SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        -Djboss.local.repository=$(pwd)/output/reposave \
        install

%{_bindir}/mvn-jpp -e \
        -s ${SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Daggregate=true \
        javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p target/%{name}-%{version_full}.jar %{buildroot}%{_javadir}/%{name}-%{version_full}.jar
%{__cp} -p target/%{name}-%{version_full}-sources.jar %{buildroot}%{_javadir}/%{name}-%{version_full}-sources.jar

pushd %{buildroot}%{_javadir}
%{__ln_s} %{name}-%{version_full}.jar %{name}.jar
%{__ln_s} %{name}-%{version_full}-sources.jar %{name}-sources.jar
popd

%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ws jbossws-common %{version} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}/
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{version_full}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version_full}.jar %{buildroot}%{repodir}/jbossws-common.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version_full}-sources.jar %{buildroot}%{repodir}/jbossws-common-src.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/jbossws-common.pom
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version_full}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version_full}-sources.jar
%{_javadir}/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Nov 25 2009 David Walluck <dwalluck@redhat.com> 0:1.1.0-1.SP1.2
- fix BuildRequires

* Thu Nov 12 2009 David Walluck <dwalluck@redhat.com> 0:1.1.0-1.SP1.1
- 1.1.0.SP1
- add javadocs

* Tue Sep 02 2008 David Walluck <dwalluck@redhat.com>  0:1.0.4-2
- fix jar location in repolib
- remove tp tarball

* Fri Aug 29 2008 David Walluck <dwalluck@redhat.com>  0:1.0.4-1
- 1.0.4.GA

* Sat Jul 26 2008 David Walluck <dwalluck@redhat.com>  0:1.0.0-2.jpp5
- rebuild

* Mon Jun 02 2008 David Walluck <dwalluck@redhat.com>  0:1.0.0-1.jpp5
- quiet setup
- use setup macro to unpack sources
- fix License

* Wed Nov 14 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.8
- Update component-info.xml to be compatible with "-brew" version of
  dependency.

* Wed Nov 14 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.7
- Quick fix to add 'version' and 'tag' attributes to the component-info.xml
  root element.

* Thu Nov 08 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.6
- Added -brew suffix for repolib

* Wed Nov 07 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.5
- First /actual/ building version

* Tue Nov 06 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.4
- Added missing defattr to files list

* Fri Nov 02 2007 Fernando Nasser <fnasser@redhat.com> 0:1.0.0-0jpp.ep1.3
- Build repolib

* Wed Oct 31 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.2
- Rebuild

* Wed Oct 31 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0-0jpp.ep1.1
- Rebuild

* Wed Oct 31 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.0.0.GA-0.1
- First release. Also, Halloween!
